# MySQL








<extoc></extoc>

## 前言

为了科学地组织和存储数据 , 实现高效获取和维护数据 , 我们需要使用一个系统软件 , 数据库管理系统 (DataBase Management System , BDMS) , 简称数据库

数据库又分为关系型和非关系型两种 : 

- 关系型数据库 : MySQL , Oracle , SqlServer , Access , Db2 , SQLite , MariaDB
- 非关系型数据库 : Redis , MongoDB , Memcached , Cassandra

## MySQL介绍

MySQL是一种快速易用的关系型数据库管理系统(RDBMS) , 由瑞典MySQL AB公司开发 , 目前属于Oracle旗下公司 , MySQL是目前最流行的关系型数据库管理系统 , 在Web应用方面MySQL是最好的RDBMS应用软件之一

具备以下优点 : 

1. 开源 , 免费使用
2. 自身功能非常强大 , 足以匹敌绝大多数功能强大但却价格昂贵的数据库软件
3. 使用业内所熟悉的标准SQL数据库语言(SQL语句通用)
4. 可运行于多个操作系统 , 支持多种语言 , 包括PHP , C , C++ , Java等语言
5. 非常迅速 , 即使面对大型数据集也毫无滞涩
6. 非常适用Web应用开发
7. 支持大型数据库 , 最高可在一个表中容纳5千多万行 ; 每张表的默认文件大小限制4GB , 不过如果操作系统支持 , 可以将期理论限制增加到800万TB
8. 可以自定义 , 开源GPL许可保证了程序员可以自由修改MySQL , 以便适应各自特殊的开发环境

**RDBMS术语**

| 术语                          | 描述                                       |
| --------------------------- | ---------------------------------------- |
| 数据库(Database)               | 数据库是带有相关数据的表的集合                          |
| 表(Table)                    | 表是带有数据的矩阵 , 数据库中的表就像一种简单的电子表格            |
| 列(Column)                   | 每一列 (数据元素) 都包含着同种类型的数据 , 比如邮编            |
| 行(Row)                      | 行 (又被称为元组 , 项或者记录) 是一组相关数据  , 比如有关订阅量的数据 |
| 冗余(Redundancy)              | 存储两次数据 , 以便使系统更快速                        |
| 主键(Primary key)             | 主键是唯一的 , 同一张表中不允许出现同样两个键值 , 一个键值只对应着一行   |
| 外键(Foreign key)             | 用于连接两张表                                  |
| 复合键(Compound key)           | 复合键 (又称组合键) 是一种由多列组成的键 , 因为一列并不足以确定唯一性   |
| 索引(Index)                   | 它在数据库中的作用就像书后的索引一样                       |
| 引用完性(Referential Integrity) | 用来确保外键一直指向已存在的一行                         |

