# Redis - 主从复制








<extoc></extoc>

## 介绍

在 Redis 中 , 用户可以通过执行 SLAVEOF 命令或者设置 slaveof 选项 , 让一个服务器去复制 (replicate) 另一个服务器 , 我们称呼被复制的服务器为主服务器 (master) , 而对主服务器进行复制的服务器则被称为从服务器 (slave)

假设现在有两个 Redis 服务器 , 地址分别为 `127.0.0.1:6379` 和 `127.0.0.1:12345` , 如果服务器 `127.0.0.1:12345` 发送以下命令 : 

```shell
127.0.0.1:12345> SLAVEOF 127.0.0.1 6379
```

那么服务器 `127.0.0.1:12345` 将成为 `127.0.0.1:6379` 的从服务器 , 而服务器 `127.0.0.1:6379` 则会成为 `127.0.0.1:12345` 的主服务器

Redis 的复制功能分为同步 (sync) 和命令传播 (command propagate)

## 同步

当客户端向从服务器发送 SLAVEOF 命令 , 要求从服务器复制主服务器时 , 从服务器首先需要执行同步操作 , 也就是 , 将从服务器的数据库状态更新至主服务器当前所处的数据库状态

从服务器对主服务器的同步操作需要通过向主服务器发送 SYNC 命令来完成 , 其执行步骤如下 : 

1. 从服务器向主服务器发送 SYNC 命令
2. 收到 SYNC 命令的主服务器执行 BGSAVE 命令 , 在后台生成一个 RDB 文件 , 并使用一个缓冲区记录从现在开始执行的所有写命令
3. 当主服务器的 BGSAVE 命令执行完毕时 , 主服务器会将 BGSAVE 命令生成的 RDB 文件发送给从服务器 , 从服务器接收并载入这个 RDB 文件 , 将自己的数据库状态更新至主服务器执行 BGSAVE 命令时的数据库状态
4. 主服务器将记录在缓冲区里面的所有写命令发送给从服务器 , 从服务器执行这些写命令 , 将自己的数据库状态更新至主服务器数据库当前所处的状态

## 命令传播

在同步操作完毕之后 , 主从服务器两者的数据库将达到一致状态 , 但这种一致并不是一成不变的 , 每当主服务器执行客户端发送的写命令时 , 主服务器的数据库就有可能会被修改 , 并导致主从服务器状态不一致

为了让主从服务器再次回到一致状态 , 主服务器需要对从服务器执行命令传播操作 : 主服务器会将自己执行的写命令 , 也即造成主服务器不一致的那条写命令 , 发送给从服务器执行 , 当从服务器执行了相同的写命令之后 , 主从服务器将再次回到一致状态

## PSYNC

由于 SYNC 命令在处理断线重复制情况下时效率低下 , Redis 从 2.8 版本开始 , 使用 PSYNC 命令代替 SYNC 命令来执行复制时的同步操作

PSYNC 命令具有完整重同步 (full resynchronization) 和部分重同步 (partial resynchronization) 两种模式 : 

- 完整重同步用于处理初次复制情况 : 完整重同步的执行步骤与 SYNC 命令的执行步骤一样 , 它们都是通过让主服务器创建并发送 RDB 文件 , 以及向从服务器发送保存在缓冲区里面的写命令来进行同步
- 而部分重同步则用于处理断线后重复制情况 : 当从服务器在断线后重新连接主服务器时 , 如果条件允许 , 主服务器可以将主从服务器连接断开期间执行的写命令发送给从服务器 , 从服务器只要接收并执行这些写命令 , 就可以将数据库更新至主服务器当前所处的状态

